// #Autoload
// #name = Demo Reminder
// #version = 1.4a
// #date = 17 Sept 2002
// #status = Release
// #author = @-Kaiten Commander
// #warrior = Kaiten Commander
// #email = kaiten@cb-tribes.co.uk
// #web = http://www.kaiten.barrysworld.net
// #description = Demo Reminder in Tournament Mode. Still a posibiltiy of Corrupt demos.
// #category = Recording
// #config = DemoReminderOptions
// #Credits = megakid & TruSoulja

if( !isObject(DemoReminder) )
{
	new ScriptObject(DemoReminder)
	{
		on = 0;
	};
}
exec("prefs/DemoReminderPrefs.cs");

package KmaDemoReminderLoad
{

	function clientCmdPickTeamMenu( %teamA, %teamB )
	{
		DemoReminder.on = 1;

		parent::clientCmdPickTeamMenu( %teamA, %teamB );
	}

	function KmaDemoReminderOff(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		if( strstr(%msgString, "Free For All") != -1 )
		{
			DemoReminder.on = 0;
			schedule(2000, 0, stopRecordingDemo, true);
		}	
	}

	function KmaDemoReminder()
	{
	 	if (!$KmaDemoToggle) return;
	
		KmaDemoReminderHUD.visible = 0;
		%time = 0;
		
		for(%i = 1; %i <= 20; %i++)
			schedule((%time += 250), 0, KmaDemoFlash);
	}
	
	function KmaDemoFlash()
	{
		if (!$KmaDemoToggle) return;
		
		KmaDemoReminderHUD.visible = !KmaDemoReminderHUD.visible;
		alxPlay(sButtonOver, 0, 0, 0);
	}
	
	function KmaDemoToggle(%val)
	{
		if(%val)
		{
			$DemoReminderToggle = !$DemoReminderToggle;
			
			if($DemoReminderToggle)
				addMessageHudLine("\c2Demo Reminder is now: ON.");
			else
				addMessageHudLine("\c2Demo Reminder is now: OFF.");
		}
	}

	function defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
	{
		parent::defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
		
		if( DemoReminder.on && !isPlayingDemo() && !isRecordingDemo())
		{
			if((strstr(%msgString, "You joined") != -1) && $DemoPref::StartOnJoinTeam)
				schedule(3000, 0, startRecordingDemo, true);
			if((StrStr(%msgString, "Match started") != -1) && $DemoPref::StartOnMatchStart)
				schedule(1000, 0, startRecordingDemo, true);		
		}
		else if(!isPlayingDemo() && isRecordingDemo())
		{
			if((StrStr(%msgString, "Match has ended") != -1) && $DemoPref::AutoStopOnEnd)
			{
				schedule(2000, 0, stopRecordingDemo, true);
			}
		}		
	}			

	function KmaDemoCheck(%msgType, %msgString, %time)
	{
		if( DemoReminder.on && !isPlayingDemo() && !isRecordingDemo() && (strstr(%msgString, "Match starts in") != -1 && %time $= $DemoPref::AnnounceTime) )
		{
			if($DemoPref::Announce = "1")
				commandToServer('teamMessageSent', "\c5"@$DemoPref::TeamMessage);
			if(!$DemoPref::StartOnMatchStart)
				KmaDemoReminder();
			%Wakeuptime = $DemoPref::AnnounceTime * 1000 + 2500;
			schedule(%Wakeuptime, 0, DemoReminderWakeup);
		}	
	}

	function OptionsDlg::onWake( %this )
	{
	
		if ( $KmaDemoReminderLoaded $= "false" )
		{
			$RemapName[$RemapCount] = "KmA Demo Reminder";
			$RemapCmd[$RemapCount] = "KmaDemoToggle";
			$RemapCount++;
			$KmaDemoReminderLoaded = "true";
		}
		parent::onWake( %this );
	}
	
	function PlayGui::onWake( %this )
	{
		if ($KmaDemoCallBack $= "false")
		{
			addMessageCallback('MsgMissionStart', KmaDemoCheck);
			addMessageCallback('MsgAdminForce', KmaDemoReminderOff);
			addMessageCallback('MsgVotePassed', KmaDemoReminderOff);
			$KmaDemoCallBack = "true";
		}
				
		parent::onWake( %this );
		
		if(!isObject(PlayGui)) return;
		
		if(isObject(KmaDemoReminderHUD)) return;
		
		new GuiControlProfile("DemoReminderTextProfile")
		{
			fontType = "Univers Condensed";
			fontSize = 18;
			fontColor = "255 0 0";
			justify = "center";
		};
		
		new GuiTextCtrl(KmaDemoReminderHUD) {
			profile = "DemoReminderTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = getword($pref::Video::resolution, 0)/2-70 @ " " @ getword($pref::Video::resolution, 1)/4;
			extent = "140 26";
			minExtent = "8 8";
			visible = "0";
			helpTag = "0";
			text = "Start Recording Now!";
			maxLength = "255";
		};
		
		if(isObject(DemoStatusHud)) return;
		
		new GuiControlProfile ("DemoStatusHudLabelProfile")
		{
			fontType = "Univers Condensed";
			fontSize = 16;
			fontColor = "255 255 64";
			justify = "center";
		};	
	
		new GuiControlProfile ("DemoStatusHudTextProfile")
		{
			fontType = "Univers Condensed";
			fontSize = 16;
			fontColor = "255 0 0";
			justify = "center";
		};
	
		new ShellFieldCtrl(DemoStatusHud)
		{
			profile = "GuiChatBackProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			extent = "55 16";
			minExtent = "8 8";
			visible = "1";
		
			new GuiTextCtrl()
			{
				profile = "DemoStatusHudLabelProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 0";
				extent = "26 16 ";
				visible = "1";
				text = "Demo";
			};
			new GuiMLTextCtrl(DemoStatusHudtext) {
				profile = "DemoStatusHudTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "33 0";
				extent = "20 16 ";
				visible = "1";
			};
		};

		PlayGui.add(KmaDemoReminderHUD);
		playGui.add(DemoStatusHud);
		DemoStatusHud.setVisible($DemoPref::ShowStatusHud);
		
		if(isObject(HM) && isObject(HudMover))
		{
			hudmover::addhud(KmaDemoReminderHUD,"Demo Reminder");
			hudmover::addhud(DemoStatusHud,"Demo Status Hud");			
		}
		
		if(!isRecordingDemo())
	        {
		      DemoStatusHudUpdate("OFF");
	    	}
	    	else
	    	{
		      DemoStatusHudUpdate("ON");
	       	}	
	}
	
	function DemoReminderOptions::onWake(%this)
	{
		%selId = $DemoPref::AnnounceId;
		DemoTimePopup.setSelected(%selId);
	}	
	
	function DemoTimePopup::onSelect(%this, %id, %text)
	{
		$DemoPref::AnnounceTime = %text;
		$DemoPref::AnnounceId = %id;
	}
	
	function DemoReminderSavePrefs(%this)
	{
		export("$DemoPref::*", "prefs/DemoReminderPrefs.cs", false);
		exec("prefs/DemoReminderPrefs.cs");	
	}
	
	function clientCmdTogglePlayHuds(%val)
	{
		parent::clientCmdTogglePlayHuds(%val);
		if($DemoPref::ShowStatusHud = "1")
			DemoStatusHud.setVisible(%val);	
	}
	
	function startRecordingDemo( %val )
	{
        	%Demo = "ON";
        	DemoStatusHudUpdate(%Demo);
        	parent::startRecordingDemo( %val );
	}

	function stopRecordingDemo( %val )
	{
        	%Demo = "OFF";
        	DemoStatusHudUpdate(%Demo);
        	parent::stopRecordingDemo( %val );
	}

	function DemoStatusHudUpdate(%Demo)
	{
		DemoStatusHudtext.setValue(%Demo);
	}
	
	function DemoReminderWakeup()
	{
		if(!isRecordingDemo())
		{
			alxPlay(InputDeniedSound, 0, 0, 0); 
			AddmessageHudline("\c0You are \c5Not\c0 Recording!!");
		}
	}
};

activatePackage(KmaDemoReminderLoad);
$KmaDemoReminderLoaded = "false";
$KmaDemoCallback = "false";
$KmaDemoToggle = 1;

if (!isObject(DemoReminderOptions))
{
       	new GuiControl(DemoReminderOptions) {
       		profile = "GuiDefaultProfile";
       		horizSizing = "right";
       		vertSizing = "bottom";
       		position = "50 50";
       		extent = "325 317";
       		minExtent = "8 8";
       		visible = "1";
       		hideCursor = "0";
       		bypassHideCursor = "0";
       		helpTag = "0";
       
       		new ShellPaneCtrl() {
       			profile = "ShellPaneProfile";
       			horizSizing = "center";
       			vertSizing = "center";
       			position = "0 0";
       			extent = "325 317";
       			minExtent = "48 92";
       			visible = "1";
       			hideCursor = "0";
       			bypassHideCursor = "0";
       			helpTag = "0";
       			text = "Demo Reminder";
       			longTextBuffer = "0";
       			maxLength = "255";
       			noTitleBar = "0";
       
       			new ShellToggleButton(DemoAnnounce) {
       				profile = "ShellRadioProfile";
       				horizSizing = "right";
       				vertSizing = "bottom";
       				position = "77 75";
       				extent = "165 36";
       				minExtent = "26 27";
       				visible = "1";
       				hideCursor = "0";
       				bypassHideCursor = "0";
       				variable = "$DemoPref::Announce";
       				helpTag = "0";
       				text = "Announce to Team";
       				longTextBuffer = "0";
       				maxLength = "255";
       				groupNum = "1";
       			};
       			new ShellTextEditCtrl(TeamMessage) {
       				profile = "NewTextEditProfile";
       				horizSizing = "right";
       				vertSizing = "bottom";
       				position = "17 110";
       				extent = "290 38";
       				minExtent = "32 38";
       				visible = "1";
       				hideCursor = "0";
       				bypassHideCursor = "0";
       				variable = "$DemoPref::TeamMessage";
       				helpTag = "0";
       				longTextBuffer = "0";
       				maxLength = "255";
       				historySize = "0";
       				password = "0";
       				IRCName = "0";
       				tabComplete = "0";
       				deniedSound = "InputDeniedSound";
       				glowOffset = "9 9";
       			};
       			new ShellPopupMenu(DemoTimePopup) {
       				profile = "ShellPopupProfile";
       				horizSizing = "right";
       				vertSizing = "bottom";
       				position = "80 38";
       				extent = "165 36";
       				minExtent = "49 36";
       				visible = "1";
       				hideCursor = "0";
       				bypassHideCursor = "0";
       				helpTag = "0";
       				longTextBuffer = "0";
       				maxLength = "255";
       				maxPopupHeight = "200";
       				buttonBitmap = "gui/shll_pulldown";
       				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
       				selectedBarBitmap = "gui/shll_pulldownbar_act";
       				noButtonStyle = "0";
       			};
       			
       			new ShellToggleButton(ShowStatusHud) {
       				profile = "ShellRadioProfile";
       				horizSizing = "right";
       				vertSizing = "bottom";
       				position = "77 150";
       				extent = "165 36";
       				minExtent = "26 27";
       				visible = "1";
       				hideCursor = "0";
       				bypassHideCursor = "0";
       				variable = "$DemoPref::ShowStatusHud";
       				helpTag = "0";
       				text = "Show Status Hud";
       				longTextBuffer = "0";
       				maxLength = "255";
       				groupNum = "1";
       			};
       			
       			new ShellToggleButton(StartOnJoinTeam) {
       				profile = "ShellRadioProfile";
       				horizSizing = "right";
       				vertSizing = "bottom";
       				position = "77 175";
       				extent = "165 36";
       				minExtent = "26 27";
       				visible = "1";
       				hideCursor = "0";
       				bypassHideCursor = "0";
       				variable = "$DemoPref::StartOnJoinTeam";
       				helpTag = "0";
       				text = "Start On Join Team";
       				longTextBuffer = "0";
       				maxLength = "255";
       				groupNum = "1";
       			};
       			
       			new ShellToggleButton(StartOnMatchStart) {
       				profile = "ShellRadioProfile";
       				horizSizing = "right";
       				vertSizing = "bottom";
       				position = "77 200";
       				extent = "165 36";
       				minExtent = "26 27";
       				visible = "1";
       				hideCursor = "0";
       				bypassHideCursor = "0";
       				variable = "$DemoPref::StartOnMatchStart";
       				helpTag = "0";
       				text = "Start On Match Start";
       				longTextBuffer = "0";
       				maxLength = "255";
       				groupNum = "1";
       			};

       			new ShellToggleButton(AutoStopOnEnd) {
       				profile = "ShellRadioProfile";
       				horizSizing = "right";
       				vertSizing = "bottom";
       				position = "77 225";
       				extent = "165 36";
       				minExtent = "26 27";
       				visible = "1";
       				hideCursor = "0";
       				bypassHideCursor = "0";
       				variable = "$DemoPref::AutoStopOnEnd";
       				helpTag = "0";
       				text = "Auto Stop On End";
       				longTextBuffer = "0";
       				maxLength = "255";
       				groupNum = "1";
       			};       			       			
       			new ShellBitmapButton() {
       				profile = "ShellButtonProfile";
       				horizSizing = "right";
       				vertSizing = "bottom";
       				position = "112 256";
       				extent = "100 38";
       				minExtent = "32 38";
       				visible = "1";
       				hideCursor = "0";
       				command = "DemoReminderSavePrefs();";
       				bypassHideCursor = "0";
       				helpTag = "0";
       				text = "SAVE";
       				simpleStyle = "0";
       			};
       		};
       	};
       	DemoTimePopup.add("5", 0);
	DemoTimePopup.add("10", 1);
	DemoTimePopup.add("15", 2);
}